KernelCAD Documentation

DInsight Home
Skip Navigation Links.
Start page
Quick Start
Installation
Overview of the software
What is new
Collapse KernelCAD ModelsKernelCAD Models
Model Structure
Securing Models
Collapse Import/ExportImport/Export
Import and Export
Collapse Adanced Data ExchangeAdanced Data Exchange
Data Flow Sample
STL Tree
IDataContext Interface
ISTLDataContext Interface
Collapse Scene ItemsScene Items
Items
3D Text
Smart Labels
View Points
Collapse MeasurementsMeasurements
Measurements
Persistent Measurements
Grid
Collapse SectionsSections
Sections
Section Types
Collapse 2D2D
Overlays
2D Models
2D Items
Point Sets
Collapse Line and Curve SectionsLine and Curve Sections
Line Strips
Line Section
3DS Curves
Collapse Surface and Solid SectionsSurface and Solid Sections
Surfaces
Collapse Mesh SectionsMesh Sections
Mesh Section
Mesh
Surface Of Revolution
BRep 3D Objects
Collapse BRep BSpline objectsBRep BSpline objects
Bspline objects
BSpline Faces
BRep Section
Pipes
Collapse 3DS Sections3DS Sections
3D Section
Profiles
Surface Patches
Surfaces and Patch Strips
Collapse AttributesAttributes
Material
Clipping Planes
Symmetries (Arrays)
Textures
Collapse OperationsOperations
Boolean Operations
Surface Trim
Cut Surface
Collapse MovementsMovements
Movements
Kinematic Sections
Collision Detection
3D Grid
Collapse Mathematical ObjectsMathematical Objects
Pure Geometric Objects
Points and Vectors
Planes
Collapse CurvesCurves
Straight Lines
3D Circle
Ellipse
Free-Form Curves
Arc Spline Curves
Frames
Transfroms
Oriented Boxes
Collapse 2D Elements2D Elements
Geometric Elements
Arcs
Line Strips
Collapse Basics of 3D GraphicsBasics of 3D Graphics
Concepts
3D View
2D View
Viewing Volume
Birds Eye View
Viewing Plane
Perspective View
Background
Collapse AlgorithmsAlgorithms
Euclidean Shortest Path
Collapse User DataUser Data
Layers
Object User Data
Model User Data
Collapse KernelCAD ComponentsKernelCAD Components
KernelCAD Control
KernelCAD .NET Control
Methods and Properties
Menu
Model Explorer
Birds Eye View
Programming
Direct User Access
Direct Operations
Interface Queries
Printing Support
Data Types
Modes of KernelCAD Control
DIObjectGenerator class
Properties
FlatObjectArray Poperty
Context
64 bit development
Dual Mode
Initialisation Context
Overlay Editor
Memory Management
Input validation
Collapse Advanced functionalityAdvanced functionality
Topological Modifications
Programming commands
Dynamic model restructuring
Dynamic Object Creation
Generator of 3D Sections
Generator of SOR Objects
Model class
Selection
Selection Event
External Models
Collapse InterfacesInterfaces
Alphabetical list
I3DGrid
I3DBugger
I3Dpt
IAxiBase
IAxis
IBoolSection
IBoolSectionEx
IBoundary
IColor
IConstraint
IData
IDiffSurface_KC
IDIFont
IDraw
IDrawUtil
IDraw2
IElem
IElement
IKCLine
ILightSource
ILocation
ILocationEx
IMaterial
IMetrics
IMetrics2
IModel
IModel2
IModelEx
IPatch
IKCPathCollisionDetector
IProfiles
IPropertyArray
IPropertyArray2
IStdShape
IStrip
ISurface
IText
ITexture
ITransform
IUnknown
Collapse Open Cascade TechnologyOpen Cascade Technology
IKO_Standard_Object
IKO_Model
IKO_TopExp_Explorer
Collapse BRepExtremaBRepExtrema
IKO_BRepExtrema_DistShapeShape
Collapse Geom2dGeom2d
IKO_Geom_CylindricalSurface
IKO_Geom_ElementarySurface
IKO_Geom2d_Circle
IKO_Geom2d_Conic
IKO_Geom2d_Curve
IKO_Geom2d_Geometry
IKO_Geom2d_Line
Collapse GeomGeom
IKO_Geom_BSplineCurve
IKO_Geom_BSplineSurface
Collapse GPGP
IKO_gp_Ax1
IKO_gp_Ax2
IKO_gp_Ax22d
IKO_gp_Ax2d
IKO_gp_Ax3
IKO_gp_Circ2d
IKO_gp_GTrsf2d
IKO_gp_Lin2d
IKO_gp_Mat2d
IKO_gp_Object
IKO_gp_Sphere
IKO_gp_Cone
IKO_gp_Torus
IKO_gp_Trsf
IKO_gp_Cylinder
IKO_gp_Pln
IKO_gp_Circ
IKO_gp_Trsf2d
Collapse GeomAPIGeomAPI
IKO_GeomAPI_PointsToBSpline
IKO_GeomAPI_Interpolate
Collapse TColStdTColStd
IKO_TColStd_Array1
IKO_TColStd_Array1OfInteger
Collapse TColgpTColgp
IKO_TColgp_Array1OfPnt
IKO_TColgp_Array1OfVec
Collapse BRepBRep
IKO_BRep_Builder
Collapse BRepBuilderAPIBRepBuilderAPI
IKO_BRep_Builder
IKO_BRepBuilderAPI_MakeWire
IKO_BRepBuilderAPI_MakeEdge
Collapse BRepOffsetAPIBRepOffsetAPI
IKO_BRepOffsetAPI_ThruSections
Collapse BRepPrimAPIBRepPrimAPI
IKO_BRepPrimAPI_MakePrism
Collapse ModModelingAlgorithmsModModelingAlgorithms
IKO_BRepGProp_Face
Collapse TopoDSTopoDS
IKO_TopoDS_Shape
IKO_TopoDS_Edge
IKO_TopoDS_Face
IKO_TopoDS_Wire
Collapse DataData
Collapse Import / ExportImport / Export
IDataConvert_KC
ICADFormat_KC
IDataContext
ISTLDataContext
IFormatVersionDataContext
Collapse User Data User Data
ILayers
IDataSource
IDataTable
IRecordSet
IDataMods
IUserData
IMatrixData
Collapse MovementMovement
IKinematicSection_KC
IMove_KC
IKinematicSet_KC
ICutEffect_KC
ISpinEffect_KC
Collapse FramesFrames
I3DObject
IFrame
IFrame2
IFrame3
IFrameEx
Collapse Oriented ObjectsOriented Objects
IObjectOriented
ISphere_KC
IBox
Collapse SectionsSections
Collapse ItemsItems
IItem
ILabel3D_KC
IDynamicScreenItem_KC
IDynamicScreenItemManager_KC
ISmartLabelManager_KC
ISection
ISection2
ISectionPointSet
ISectionLineStrip
ITextSection_KC
IPipeSection
ILineSection_KC
IObjectPosition_KC
ISticky_KC
ILabelSection_KC
IModelHealer_KC
IPointCloud_KC
IProfiledElement_KC
Collapse Mesh interfacesMesh interfaces
IMesh
IMeshTopol
ISimplex
IMeshMods
IVertex
IMeshEx
IIterator
IMeshPointKC
ISurfacePointKC
ISurfaceMetric_KC
IVertexEx_KC
IEdge_KC
ISimplexEx_KC
IMeshAlgor
IMeshShading_KC
Collapse GeneralGeneral
Collapse Collections InterfacesCollections Interfaces
IArray
IArray2
IList
IListUnkn_KC
IRelation
IArrayNum
IArray3D
IRefMap_KC
IObject_KC
ITypeBasic_KC2
IModelSearch_KC
IBitmap
IBlob
IKCContext
IKCContext2
IError_KC
IKCStack
ILineStyle_KC
IMenu_KC
IMenuItem_KC
IGlobalAPI_KC
IControlInitialisationContext_KC
IRange
IRectangleAxisAligned_KC
Collapse Topological InterfacesTopological Interfaces
IStripTopol
I3DSectionGenerator
ISORSectionGenerator 
IDIObjGenerator
Collapse Viewing InterfacesViewing Interfaces
IView
IView2
IViewPoint
IViewPointArray
ILookAt
IViewModal
ILook
ILookEx
IMeasurement_KC
IPick
ISelection_KC
IRectangleColor_KC
I2DView_KC
I2DView2_KC
I2DEditor_KC
IPrint_KC
IVirtualView
IGraphicItem
Collapse Lines And CurvesLines And Curves
ILine
ILineGeom
ILineMetr
ICurve
ICurveFreeForm
ICurveFreeFormEx
IArcSpline3DCurve
IArc
IArcEx
ICircle3D_KC2
IEllipse_KC
Collapse Symmetry InterfacesSymmetry Interfaces
ISymmetries
ISymmetry
IAxialSymmetry
Collapse Clipping plane interfacesClipping plane interfaces
IClipArray
IClipPlane
Collapse AlgorithmsAlgorithms
IEuclideanShortestPath_KC
Collapse 2D Geometry2D Geometry
ILine2D
IArc
IArcEx
IStripArcLine_KC
Collapse Programming Samples and TutorialsProgramming Samples and Tutorials
Collapse OverviewOverview
Sample List
3DBugger
BoolOp
PlanarOps
Calculator
Capture
Cannon
Clip
Cloud
Collision
Collision Path
Cross View
Data Flow
Data Flow
Deploy Tutorial
DiffSurface
Direct User Access Demo
DIView
eMotion
Euclidean Shortest Path
Gear
Label
LabelEx
Layers
Light
Lines
LowDim
Make Your Move
Measure
Mesh Mods
MeshOps
Metrics
MiniCAD
Modal
Modeling Curves
Morph
Object Array
Overlay
Patch
Patchwork
Pick
Point Of View
BoolOp
Profile
Rotation
Pipes
Layers
Shape Explorer
Smart Labels
Strip Topology
Surface Metrics
Symmetry
Transform
Texture
Turbine
TwoD
User Data
View Point
WpfCAD
Zoom
Collapse DeploymentDeployment
Deploy Tutorial
DeployModule
DeployWixBasic
WixDeploy
Collapse .NET Samples.NET Samples
Collapse C# SamplesC# Samples
Patch Tutorial
MiniCAD Sample
Strip Topology Sample
DI View Sample
Modal View Sample
Modeling Curves
Label
LabelEx
Pick
Object Array
Data Flow
Profile
Cross View
Low Dim
Morph
Clip
BoolOp
Collision
Collision Path
3DBugger
Data Flow
Shape Explorer
Smart Labels
Symmetry Sample
Cannon
View Point Sample
Capture
User Data
Layers
Zoom
Collapse Visual Basic SamplesVisual Basic Samples
Patch Tutorial
DI View Sample
MiniCAD Sample
Object Array Sample
BoolOp
Data Flow
Pipes
Transform
Measure
Mesh Mods
Mesh Ops
Metrics
Morph
TwoD
eMotion
Cross View
3DBugger Tutorial
Collision
Collision Path
Light
Patchwork
Capture
Collapse WPFWPF
Clip
Mesh Ops
Measure
Lines
LowDim
WPF
Patch
Collapse Delphi SamplesDelphi Samples
3DBugger
BoolOp
Calculator
Patch Sample
Modelling Curves
MiniCAD Sample
Morph
Shape Explorer
Object Array
Metrics
Cannon
Pipes
Patchwork
Collision
Collapse C++ SamplesC++ Samples
3DBugger
BoolOp
Cannon
Capture
Cloud
Collision
Collision Path
Cross View
DI View Sample
eMotion
Gear Sample
Label
LabelEx
Light Sample
Measure
Mesh Ops
MiniCAD Sample
Modal Sample
Modeling Curves
Object Array Sample
Overlay Sample
Patch Tutorial
Pick
Point Of View
Planar Ops
Rotation Sample
Profile Sample
Shape Explorer
Smart Labels
Strip Topology Sample
Layers
Lines
LowDim
Metrics
Metrics2
Morph Sample
Patchwork
Pipes
Symmetry Sample
Texture Sample
Transform
TwoD
Turbine Sample
User Data
View Point Sample
Zoom Sample
Collapse Visual Basic SamplesVisual Basic Samples
Patch
DI View
MiniCAD
Data Flow
Cross View
Cloud
Planar Ops
Calculator
Light
Pick
Object Array
Label
Symmetry
Transform
Morph
Line Strip
Capture
Collapse Delphi SamplesDelphi Samples
KernelCAD and Delphi
3DBugger
Data Flow
BoolOp
Calculator
Cannon
Collision
Label
LabelEx
Metrics
MiniCAD
ModelingCurves
Object Array
Patch
Patchwork
Pipes
Collapse 3D Debugger3D Debugger
Creating and editing models
Editing Generic 3D Objects
Topological Commands
Model Explorer
Export / Import
Modeling Tips
3D Debugger
Collapse EditorsEditors
Form View
3D View
Collapse 2D Editors2D Editors
Crossection View
Profile View
Drum View
Collapse DialogsDialogs
3D Curve Dialog
Symmetry Collection Editor
Clip Editor
Material Editor
Surface options dialog
Collapse Modelling TutorialsModelling Tutorials
Table Tutorial
Mouse Tutorial
Collapse DeploymentDeployment
Redistribution
Registration
Deploy Module Tutorial
WixDeploy Tutorial
DeployWixBasic
Deploy Tutorial
Licensing
Model Viewer
Open C++ Source
Technical Support
Skip Navigation LinksHome Page > 3D Debugger > Modelling Tutorials > Table Tutorial
Table Tutorial

Table Modeling Tutorial

This tutorial will demonstrate creation and modification of simple DInsight models. We are going to create model of a table. It is recommended to keep the target model Table.glm located in Models\Tutorial\Table folder of the installation directory (C:\Program Files\DInsight\ by default ) opened in another instance of 3D Debugger for reference during the modeling.

Step 1. Creating top of the table.

Step 2. Creating leg of the table.

Step 3. Joining legs to the table.

Step 4. Creating frame of the table.

 

Step 1. Creating top of the table.

  • Launch 3D Debugger or, if it is already open, select File > New menu command. Select Model > "New Object" menu command. Make sure that Solid\General\Box node is selected in the tree control of the dialog. In the Object Name edit box type "Top" to be able to distinguish the object later in Model Explorer. Press Modify button and enter dimensions 120, 80, and 3 starting from the top edit box. Pres OK two times to create the object. Save the model model using File > SaveAs menu command. 
  • Later, after the model is finished, you can change shape and dimensions of the table top by selecting points and segments in cross-section and dragging them around. You can also change any side to an arc by using "Change Class" command and modifying its curvature with the mouse or by using "Cur Elem" page of the form.
  • Hide the local axes by clearing "Show Local Frame" check box on "Cur Sect" tab.
  • Select an appropriate color by using Options dialog available on "Current Object" > Options menu command. Default color is displayed when the object is not selected as current.. To see the color in 3D view, open Model Explorer ( Model > Explore ), select the "Top" node ( the only one currently available ) and press "Make Not Current" button. This will deactivate the object and will show its natural color. Press the button again to make the Top object current.
  • To add a texture to the top open "Current object">Material. Select Texture > Load from the menu. Browse to DInsight\Data\Textures\Wood folder and select wood001.bmp file. Check "Use loade texture check box at the top. Press OK."
  • The top is ready. Save the model using File > Save or by pressing "s" while holding the Control key.

 

Step 2. Creating leg of the table.

  • Select Model > New Object. In the appeared New Object dialog select Solid\ Rotation Symmetric\Cylinder node. In Object Name edit box type "Leg". Press Modify button to change default dimensions. In the appeared dialog type 2 for radius and 70 for Height. Press OK. Press OK in the New Object dialog. 
  • Use the right mouse button to zoom in appropriately. Note that grid changes accordingly, which helps to make more precise mouse operations.
  • We will make shape of the leg curved. Press "Break Line" command button on "Cmd" tab and click on the segment in Cross-section View at approximately x = 13.0 position. This will add a new point to the segment. Add another point at approximately x=25.0. Select the segment between these two new points and change it to an arc using "Change Class" command from the context menu (right mouse click in the window). Drag the middle of the arc up a little  to change its curvature.
  • If no changes appear in 3D view, increase geometrical resolution for surface calculation For this small feature to be drawn properly the resolution 20 should be enough. In Options dialog, available from "Current Object" > Options command, type 20 in "Simplex per dim" box and press OK. Remember that increasing resolution improves appearance of the surface but also significantly increases computational load on the computer.
  • Select the point at x = 0.0 and drag it up a little to make the top joint of the leg to look more stable. 
  • If you wish, make further modification to the leg  in a similar fashion according to you taste. 
  • Open "Cur Sect" tab of the form view. This tab allows changing position of the current object, which currently is the leg, with respect to global axes of the model and hence with respect to the table top. Select "z" radio button. Click into "Translate by" edit box. Its background should turn green, which means that this edit box is currently attached to the form's slider. Move slider slightly down to move the leg away from the top surface. Then, switching between x and y radio buttons and using the slider, move the leg into corner of the table. If slider has reached its limit release the button. It will be positioned in the center again so you can continue the movement.
  • Select appropriate color by using sub menu "Current Object" > Options dialog. This color can also be saved into Catalogue  for later use in other parts of the model or other models. See Catalogue

Step 3. Joining legs to the table.

  • The leg should be joined to the top of the table so that whole table can be moved in 3D as a solid object. To join, use Model > Explore menu command.  In the tree on the left the "Leg" node should be draw current ( its icon should have green background). Select "Top" node in the tree and in the dialog's menu select Action > Join. Leg will become child object of the Top object, which will be reflected in the dialogs tree control. Close the Model Explorer.
  • The previous operation did not change anything in 3D view. To make sure that objects are joined correctly save the model to keep a backup. Modify position of the leg using edit boxes from the  "Cur Obj" tab. Notice that the top of the table moves with the leg. This would also happened if we have selected Top as the current object and moved it in any way. Press Undo button on the tab to restore original position.
  • Next we will add three copies of the leg. One way to do that is to save the leg into a separate model and use Import Objects operation three times.  Instead, we will do it by using symmetries.
  • Select "Current Object" > Symmetries menu command. In the opened Symmetries dialog select Mirror radio button and press Add. "Mirror symmetry" will appear in the list. Make sure it is selected and press Properties button. In the opened Mirror Symmetry dialog check Show option to see the mirror plane in 3D. In Location group enter 30 into Y edit box. In the Direction group set X, Y and Z values to 0, 1, and 0 respectively. The mirror plane will be positioned in the middle of the table along its longer side. A copy of the leg will appear on its other side. Clear Show check box and close the Mirror symmetry dialog.
  • To add the other two legs we could have added another mirror symmetry. Instead, we will try Translation symmetry. Open Symmetries dialog again, select Translation and press Add button. Select Translation in the list, open its properties and enter 100, 0, 0 into X, Y and Z edit boxes respectively. Close the dialog. Another two copies of the leg (or rather another copy of the previous pair ) will appear in 3D.
  • Hide local axes by clearing "Show Local Frame" check box on "Cur Sect" tab and save the model.

Step 4. Creating frame of the table.

  • Here we will create a simple flat plank to use it in assembly of the table. Open New Object dialog and make sure Solid\General\Box node is selected. Enter "Short Plank" name for the object. Press Modify button. and enter X=2, Y=62, Z=9 for dimensions. Press OK twice to create the object.
  • Move the plank using "Cur Obj" form page to connect two legs on the left side of the table. More precisely: Select x axis. In the "Translate by" edit box type 10 and press tab key. Select y axis and enter 10 into the "Translate by" box..
  • To add a replica of the plank of the opposite side open "Current Object">Symmetries dialog. In "New Symmetry" group select Translation and press Add. Press Properties button. Enter for the translation vector (100, 0, 0) and press OK.
  • Clear "Show Local Frame" check box on "Cur Sect" tab.
  • Join the plank to the Top section like in the beginning of the Step 3.
  • Set color close to one of the leg using "Current Object" > Options dialog. You can also use stored materials to keep colors consistent.  See Catalogue.
  • Create another plank for the rear part of the table frame by adding a new box object like above with dimensions X=100, Y=2 and Z=9. 
  • Position the plank between rear legs and join it to the Top section.
  • The front plank of the frame will be different, so we will not use symmetries. Create new box with with dimensions X=9, Y=2 and Z=100. 
  • Open "Cur Obj" page of the form, select y axis and type -90 in the Rotate by edit box. Press the Tab key. The plank will be rotated clockwise around its y axis.
  • Position the plank between the front legs by using "Translate by" edit box and y and z radio buttons. Note that movements happen with respect to the local axes. To avoid confusion hide temporarily global frame using "3D" page of the form. 
  • Join the plank to the Top section.
  • As the last improvement for the table we will make the front plank curved.  In Cross-section View (Bottom right window) select the bottom right point. Correspondent edge of the plank will be highlighted in 3D View. Select straight line which appeared in Profile View (bottom left window). From the context menu (right mouse) select "Change Class" option. Click OK. Drag middle of the line down so that table frame will be curved to make more room underneath. Do the same operation for the other edge of the plank by selecting the top right point in Cross-section View and repeating the procedure. 
  • To view the result, in the Model Explorer (Model > Explorer) select the current object in the tree and press "Make not current" button. All sections will be rendered in their natural non-selected color. 
  • Save the model

Note that you can select any part of the model with the help of Model Explorer and make any additional modifications. For real life modeling you would also adjust dimensions to exact ones by using edit boxes from Current Object page or Properties dialogs from context menus.